#include "Calculation.h"
using namespace std;

/* Maximum bounds */
double maxlimits[PARAMS];
/* Minimum bounds */
double minlimits[PARAMS];
/* The time of counting glocose */
std::vector<double> *intersticial_time;
/* The value in glocose */
std::vector<double> *intersticial;
/* The time of counting blood */
std::vector<double> *blood_time;
/* The value in blood */
std::vector<double> *blood;
/* The array for save each segment id */
int * segmentid;
/* Count of segments */
int total_segments;
/* Count of iteration of algorithm */ 
int iterations;

/* Parameters for calculation */
int min_set_of_params;
double A;
double B;
double G;
double H;
double precision;

/* The variables a necessary for callbacks and saving each values */
int index_to_array;
int oldSegment;
int newSegment;
bool first_setup;

/*
The function for calculation serial choice or TBB

parameters: the database
*/
double * calculation_process(int aIndex_to_array_segment){

	int iter = iterations;
	int curr_segment = aIndex_to_array_segment;

	// generate set of parameters (min. 7 - its need for algorithm)
	std::vector<double *> set_of_params;
	for(int x = 0; x < min_set_of_params; x++) {
		set_of_params.push_back(generate_parameters());	
	}	
	
	// interpolation for current segment
	alglib::spline1dinterpolant *interpolant = spline_interpolation(curr_segment);

	//fprintf(stdout, "Counting metrics for all set of parameters\n", curr_segment);
	for(int j = 0; j < min_set_of_params; j++) {
		// save the result of metrics for all set of parameters
		set_of_params[j][6] = count_metrics(interpolant, set_of_params[j], curr_segment);
	}

	// sort params by metrics
	set_of_params = sort_params_by_metric(set_of_params);

	// initialization variable of termination criteria 
	double best_metric = set_of_params[0][6];
	int metric_no_change = 0;
	int max_iteration_no_change = iter/2;
	double Xg, Xr , Xc, Xe, metric_xr, metric_xc, metric_xe;

	// apply algorithm
	for(int counting = 0; counting < iter; counting++) {

		// test a best metric
		if(set_of_params[0][6] == best_metric) {
			metric_no_change++;
		} else {
			metric_no_change = 0;
			best_metric = set_of_params[0][6];
		}

		// test two termination criteria
		if(max_iteration_no_change == metric_no_change){
			break;
		}
		if(best_metric < precision){
			break;
		}

		// reflection
		double * new_params = new double[PARAMS+1];
		//double Xg, Xr;
		for(int curr_param = 0; curr_param < PARAMS; curr_param++){
			Xg = 0;
			Xr = 0;

			for(int idx = 0; idx < min_set_of_params-1; idx++){
				Xg += set_of_params[idx][curr_param];
			}
			Xg = Xg/(min_set_of_params-1);
			Xr = (A*(Xg-set_of_params[min_set_of_params-1][curr_param]))+Xg;

			// insert the new param 
			new_params[curr_param] = Xr;
		}

		// check border of parameters
		new_params = check_border_parameters(new_params);
		// counting new metric for new set of params
		metric_xr = count_metrics(interpolant,new_params,curr_segment);
		// save mertic
		new_params[6] = metric_xr;

		if((set_of_params[0][6] < metric_xr) && (metric_xr < set_of_params[min_set_of_params-2][6])) {
			set_of_params[min_set_of_params-1] = new_params;
		} else {
			if(set_of_params[0][6] < metric_xr) {
				//contraction
				double * params_xc = new_params;
				//double Xc = 0;
				for(int curr_param = 0; curr_param < PARAMS; curr_param++){
					Xc = (G*(set_of_params[min_set_of_params-1][curr_param]-Xg))+Xg;
					params_xc[curr_param] = Xc;
				}
				// check border of parameters
				params_xc = check_border_parameters(params_xc);
				// counting new metric for new set of params
				metric_xc = count_metrics(interpolant,params_xc,curr_segment);
				params_xc[6] = metric_xc;
				if(metric_xc < set_of_params[min_set_of_params-1][6]){
					set_of_params[min_set_of_params-1] = params_xc;
				} else {
					//multicontraction
					for(int curr_set = 1; curr_set < min_set_of_params; curr_set++){
						for(int curr_param = 0; curr_param < PARAMS; curr_param++){
							set_of_params[curr_set][curr_param] = (H*(set_of_params[curr_set][curr_param]-set_of_params[0][curr_param]))+set_of_params[0][curr_param];
						}
						// check border of parameters
						set_of_params[curr_set] = check_border_parameters(set_of_params[curr_set]);
						set_of_params[curr_set][6] = count_metrics(interpolant, set_of_params[curr_set],curr_segment);
					}
				}
			} else {
				//expansion
				double * params_xe = new_params;
				//double Xe = 0;
				for(int curr_param = 0; curr_param < PARAMS; curr_param++){
					Xe = (B*(new_params[curr_param]-Xg))+new_params[curr_param];
					// insert the new param 
					params_xe[curr_param] = Xe;
				}
				// check border of parameters
				params_xe = check_border_parameters(params_xe);
				// counting new metric for new set of params
				metric_xe = count_metrics(interpolant,params_xe,curr_segment);
				params_xe[6] = metric_xe;
				if(metric_xe < metric_xr){
					set_of_params[min_set_of_params-1] = params_xe;
				} else {
					set_of_params[min_set_of_params-1] = new_params;
				}
			}
		}
		// sort params by metrics
		set_of_params = sort_params_by_metric(set_of_params);
	}

	return set_of_params[0];
}

/*
Show result of calculation

parameters: array of result

*/
void show_statistics(std::vector<double *> aResults){

	fprintf(stdout, "\nThe information of calculation\n");
	fprintf(stdout, "----------------------------------------------\n");
	fprintf(stdout, "Count of iterations: %d\n", iterations);
	fprintf(stdout, "Count of segments: %d\n", total_segments);
	fprintf(stdout, "Count of parameter sets: %d\n", min_set_of_params);
	fprintf(stdout, "Constants for counting:\n");
	fprintf(stdout, "A = %f\n",A);
	fprintf(stdout, "B = %f\n",B);
	fprintf(stdout, "G = %f\n",G);
	fprintf(stdout, "H = %f\n",H);
	fprintf(stdout, "Premature termination criteria:\n");
	fprintf(stdout, "Count of iteration for the best metric without change: %d\n", iterations/2);
	fprintf(stdout, "The metric is less than: %f\n", precision);
	fprintf(stdout, "Bounds for counting:\n");
	fprintf(stdout, "Pmin  = %f\tPmax  = %f\n", minlimits[0], maxlimits[0]);
	fprintf(stdout, "Cgmin = %f\tCgmax = %f\n", minlimits[1], maxlimits[1]);
	fprintf(stdout, "Cmin  = %f\tCmax  = %f\n", minlimits[2], maxlimits[2]);
	fprintf(stdout, "Dtmin = %f\tDtmax = %f\n", minlimits[3], maxlimits[3]);
	fprintf(stdout, "Hmin  = %f\tHmax  = %f\n", minlimits[4], maxlimits[4]);
	fprintf(stdout, "Kmin  = %f\tkmax  = %f\n", minlimits[5], maxlimits[5]);

	fprintf(stdout, "\nThe results (bounds are cut to 5 decimal places):\n");
	fprintf(stdout, "----------------------------------------------\n");
	for(int curr_segment = 0; curr_segment < total_segments; curr_segment++){
		// the bug and idk why...
		if(curr_segment == 0){
			fprintf(stdout, "Segment: %d\tmetric = %f \n", 0, aResults[curr_segment][6]);
		}else {
			fprintf(stdout, "Segment: %d\tmetric = %f \n", segmentid[curr_segment], aResults[curr_segment][6]);
		}
		fprintf(stdout, "p  = %.5f\tcg = %.5f\tc = %.5f\ndt = %.5f\th  = %.5f\tk = %.5f\n", aResults[curr_segment][0],aResults[curr_segment][1],aResults[curr_segment][2],aResults[curr_segment][3],aResults[curr_segment][4],aResults[curr_segment][5]);
		fprintf(stdout, "----------------------------------------------\n");
	}
}

/*
Function for save result to database

parameters: instance of the database
vector of arrays with results
*/
void save_result_db(sqlite3 *aDatabase, std::vector<double *> aResults){

	char *zErrMsg = 0;
	int rc;
	char *sql; 
	fprintf(stdout, "Insert the results serial calculation to database\n");
	for(int curr_segment = 0; curr_segment < total_segments; curr_segment++){

		// create a request
		sql = sqlite3_mprintf("INSERT INTO difuse2params (id,p, cg, c, dt, h, k, s, segmentid) VALUES (null,%f,%f,%f,%f,%f,%f,%d,%d)", aResults[curr_segment][0],
			aResults[curr_segment][1],
			aResults[curr_segment][2],
			aResults[curr_segment][3],
			aResults[curr_segment][4],
			aResults[curr_segment][5],1,segmentid[curr_segment]);

		// execute the request
		rc = sqlite3_exec(aDatabase, sql, NULL, NULL, &zErrMsg);
		if (rc != SQLITE_OK){
			fprintf(stderr, "SQL error during saving results: %s\n", zErrMsg);
			sqlite3_free(zErrMsg);
		}

	}
	//sqlite3_free(sql);	
}

/*
Check borders for each new parameters. When isn't right border then set border from file.

parameters: array with new parameters

return array with the right borders
*/
double * check_border_parameters(double aNew_params[]){
	// check border of parameters
	for(int idx = 0; idx < PARAMS; idx++) {
		if(aNew_params[idx] < minlimits[idx]) {
			aNew_params[idx] = minlimits[idx];
		} else if(aNew_params[idx] > maxlimits[idx]) {
			aNew_params[idx] = maxlimits[idx];
		}
	}
	return aNew_params;
}

/*
Count metric for current parameters and segment.

parameters: interpolant for current segment
array of parameters
current segment

return metrics for this parameters
*/
double count_metrics(alglib::spline1dinterpolant *aInterpolant, double *aSet_of_params, int aCurr_segment){

	/* Initialization a necessary variables for counting metric */
	double result_metric = 0;
	double sum_rel_error = 0;
	double rel_error = 0;
	double sum_variance = 0;
	double equation_1,equation_2,equation_3,equation_4,equation_5,equation_6,result_rel_error,variance, time;
	double max_time = get_max_time(intersticial_time[aCurr_segment]);
	double min_time = get_min_time(intersticial_time[aCurr_segment]);
	double count = blood[aCurr_segment].size();
	double total_count = count;

	for(int k = 0; k < total_count; k++) {
		// get time
		time = blood_time[aCurr_segment][k];	

		// counting all equations
		equation_1 = time+aSet_of_params[3]+(aSet_of_params[5]*((alglib::spline1dcalc(*aInterpolant, time)-alglib::spline1dcalc(*aInterpolant, time-aSet_of_params[4])))/aSet_of_params[4]);
		if(equation_1 < min_time || equation_1 > max_time) {
			count--;
			continue;
		}
		equation_2 = aSet_of_params[1];
		equation_3 = aSet_of_params[0] - (equation_2 * alglib::spline1dcalc(*aInterpolant, time));
		equation_4 = aSet_of_params[2] - alglib::spline1dcalc(*aInterpolant, equation_1);
		equation_5 = pow(equation_3, 2) - (4*equation_2*equation_4);
		if(equation_5 < 0.0){
			equation_5 = 0.0;
		}
		equation_6 = (-equation_3 + sqrt(equation_5))/(2*equation_2);

		// update metrics
		rel_error = abs(blood[aCurr_segment][k] - equation_6)/blood[aCurr_segment][k];
		sum_rel_error += rel_error;	
		sum_variance += pow(rel_error,2);
	}

	// evaluation values
	if(count == 0) {
		result_metric = DBL_MAX;
	} else {
		result_rel_error = sum_rel_error/count;
		variance = (sum_variance / count) - pow(result_rel_error, 2);
		variance = sqrt(variance);
		result_metric = result_rel_error+variance;
	}

	return result_metric;
}

/*
Sort all set of parameters by metrics asc.

parameters: vector of arrays set of parameters

return sorted vector by metric
*/
std::vector<double *> sort_params_by_metric(std::vector<double *> aSet_of_params){
	int count = aSet_of_params.size();
	double * temp;
	for(int i = 0; i < count; i++) {
		// getting a first metric
		double pom =  aSet_of_params[i][6];
		// compare with the other values	
		for(int k = i+1; k < count; k++) {
			if(pom > aSet_of_params[k][6]) {
				// swap
				pom = aSet_of_params[k][6];
				temp = aSet_of_params[i];
				aSet_of_params[i] = aSet_of_params[k];
				aSet_of_params[k] = temp;
			}
		}
	}
	return aSet_of_params;
}

/*
Counting interpolant for request segment

parameters: current segment

return the pointer of interpolation for counted value
*/
alglib::spline1dinterpolant* spline_interpolation(int aSegment) {
	alglib::spline1dinterpolant *interpolant = new alglib::spline1dinterpolant();
	alglib::real_1d_array x;
	alglib::real_1d_array y;

	/* Convert on real_1d_array from library alglib */
	x.setcontent(intersticial_time[aSegment].size(), &(intersticial_time[aSegment][0]));
	y.setcontent(intersticial[aSegment].size(), &(intersticial[aSegment][0]));
	try {
		alglib::spline1dbuildakima(x, y, *interpolant);
	}
	catch (alglib::ap_error e) {
		fprintf(stdout, "Error msg: %s\n", e.msg.c_str());
	}

	return interpolant;
}

/*
Clean up after my self.

parameters: instance of database
*/
void clean_up(sqlite3 *aDatabase){
	sqlite3_close(aDatabase);
	delete[] blood;
	delete[] blood_time;
	delete[] intersticial;
	delete[] intersticial_time;	
	delete[] segmentid;
}

/*
Loading a config file

parameters:	the name of config file

return true when all parameters are loaded otherwise false
*/
void load_config(std::string aName) {
	std::ifstream inputFile(aName);
	std::string line;
	int check_num_param = 0;
	std::string delimiter = "=";
	size_t pos = 0;
	std::string token;
	std::string option;

	while (getline(inputFile, line)) {
		std::istringstream ss(line);

		pos = line.find(delimiter);

		if (pos != std::string::npos) {
			option = line.substr(0, pos);
			token = line.substr(pos + delimiter.length(), line.length());

			if (option.compare("iterations") == 0) {
				int temp = atoi(token.c_str());
				if (temp > 0) {
					iterations = temp;
					check_num_param++;
				}
			}
			else if (option.compare("min_set_of_params") == 0) {
				int temp = atoi(token.c_str());
				if (temp > 0) {
					min_set_of_params = temp;
					check_num_param++;
				}
			}
			else if (option.compare("precision") == 0) {
				double temp = atof(token.c_str());
				if (temp > 0) {
					precision = temp;
					check_num_param++;
				}

			}
			else if (option.compare("A") == 0)	{
				A = atof(token.c_str());
				check_num_param++;
			}
			else if (option.compare("B") == 0)
			{
				B = atof(token.c_str());
				check_num_param++;
			}
			else if (option.compare("G") == 0)
			{
				G = atof(token.c_str());
				check_num_param++;

			}
			else if (option.compare("H") == 0)
			{
				H = atof(token.c_str());
				check_num_param++;
			}
		}
	}

	if(check_num_param != 7){
		fprintf(stderr, "Missing some parameters for calculation - check file or use to documentation.\n");
		wait_for_exit();
	}
}

/*
Opening a database and loading all segments.

parameters: pointer on database
name of database

return - true when database is opened otherwise false
*/
bool open_database(sqlite3 **aDatabase, char *aDatabase_name) {
	int rc;
	char *zErrMsg = 0;

	/* Open database */
	rc = sqlite3_open(aDatabase_name, aDatabase);
	if (rc) {
		fprintf(stderr, "Cannot open database (or not found): %s\n", sqlite3_errmsg(*aDatabase));
		wait_for_exit();
	} else {		
		/* Create SQL statement */
		char *sql_num_rows = (char*)malloc(1024 * sizeof(char)); // "Select count(segmentid) from measuredvalue group by segmentid";
		strcpy(sql_num_rows, "Select count(segmentid) from measuredvalue group by segmentid");		
		/* Execute SQL statement */
		rc = sqlite3_exec(*aDatabase, sql_num_rows, callback_total_seq, 0, &zErrMsg);

		if (rc == SQLITE_OK) {
			//fprintf(stderr, "Opened database successfully\n");
			free(sql_num_rows);
			return true;
		} else {
			fprintf(stderr, "Failed to open database\n");
			free(sql_num_rows);
			wait_for_exit();
		}
	}
	return false;
}

/*
Callback for loading all segments.
*/
int callback_total_seq(void *data, int argc, char **argv, char **azColName) {
	total_segments++;
	return 0;
}

/*
Callback for loading all time counting glucose in blood.
*/
int callback_read_blood(void *data, int argc, char **argv, char **azColName) {
	newSegment = atoi(argv[2]);
	// first setup
	if(first_setup){
		oldSegment = atoi(argv[2]);
		first_setup = false;
		segmentid[index_to_array] = oldSegment;
	}

	if(oldSegment != newSegment){
		oldSegment = newSegment;
		index_to_array++;
		segmentid[index_to_array] = oldSegment;
	}

	blood_time[index_to_array].push_back(convert_time_to_double(argv[0]));
	blood[index_to_array].push_back(atof(argv[1]));
	return 0;
}

/*
Callback for loading all time counting glucose in intersticial.
*/
int callback_read_intersticial(void *aData, int aArgc, char **aArgv, char **aAzColName) {

	newSegment = atoi(aArgv[2]);

	// first setup
	if(first_setup){
		oldSegment = atoi(aArgv[2]);
		first_setup = false;
	}

	if(oldSegment != newSegment) {
		oldSegment = newSegment;
		index_to_array++;
	}

	intersticial_time[index_to_array].push_back(convert_time_to_double(aArgv[0]));
	intersticial[index_to_array].push_back(atof(aArgv[1]));
	return 0;
}

/*
Loading data from database.

parameters: pointer on database
*/
void load_data_from_db(sqlite3 *aDatabase) {

	//fprintf(stdout, "Loading data\n");

	char *zErrMsg = 0;
	int rc;
	char *sql_ist = (char*)malloc(1024 * sizeof(char));
	char *sql_blood = (char*)malloc(1024 * sizeof(char));

	blood = new std::vector<double>[total_segments + 1];
	blood_time = new std::vector<double>[total_segments + 1];
	intersticial = new std::vector<double>[total_segments + 1];
	intersticial_time = new std::vector<double>[total_segments + 1];
	segmentid = new int[total_segments];

	strcpy(sql_ist, "select measuredat, ist, segmentid from measuredvalue where ist not null group by segmentid, measuredat order by segmentid");
	/*sprintf_s(sql_ist, 1024, "select measuredat, ist, segmentid from measuredvalue where ist not null group by segmentid, measuredat order by segmentid");
	sprintf_s(sql_blood, 1024, "select measuredat, blood, segmentid from measuredvalue where blood not null group by segmentid, measuredat order by segmentid");*/
	strcpy(sql_blood,"select measuredat, blood, segmentid from measuredvalue where blood not null group by segmentid, measuredat order by segmentid");

	index_to_array = 0;
	oldSegment = 0;
	newSegment = 0;
	first_setup = false;
	rc = sqlite3_exec(aDatabase, sql_blood, callback_read_blood, NULL, &zErrMsg);
	index_to_array = 0;
	oldSegment = 0;
	newSegment = 0;
	first_setup = false;
	rc = sqlite3_exec(aDatabase, sql_ist, callback_read_intersticial, NULL, &zErrMsg);

	if (rc != SQLITE_OK){
		fprintf(stderr, "SQL error: %s\n", zErrMsg);
		sqlite3_free(zErrMsg);
	}
	else{
		//fprintf(stdout, "Data read successfully\n");
	}

	free(sql_ist);
	free(sql_blood);
}

/*
Loading bounds from file. Bounds are save to prepared arrays.

parameters:	file with bounds
*/
void load_bounds(std::string aName)
{
	std::ifstream inputFile(aName);
	std::string line;
	std::string delimiter = "=";
	std::string token;
	size_t pos = 0;

	int i = 0;
	int j = 0;

	while (std::getline(inputFile, line)) {
		std::istringstream ss(line);		
		pos = line.find(delimiter);

		if (pos != std::string::npos) {
			token = line.substr(pos + delimiter.length(), line.length());

			if (j == 1)	{
				maxlimits[i] = atof(token.c_str());
				i++;
				j = 0;
			} else	{
				minlimits[i] = atof(token.c_str());
				j++;
			}
		}
	}
}
