#include "MPI.h"

/*
The farmer for split works and processing results

parameters:
sqlite3 *aDatabase	- instance of database for save results 
int aWorkers		- the count of processes (workers)
*/
void farmer (sqlite3 *aDatabase, int workers) {

	MPI_Status status;
	int count = total_segments;


	// Assume at least as many tasks as workers
	int i=0;
	for (i=0; i < workers-1; i++) {
		// sending an index to array of segments
		MPI_Send(&i, 1, MPI_INT, i+1, 1, MPI_COMM_WORLD);
		count--;
	} 

	// The results of the best parametrs for each segment
	std::vector<double *> result_array;

	int who;
	// sending and receiving a results for segments
	while (count > 0) {
		double * result = new double[PARAMS+1];
		// receive respone
		MPI_Recv(result, PARAMS+1, MPI_DOUBLE, MPI_ANY_SOURCE, 2, 
			MPI_COMM_WORLD, &status);
		// save result
		result_array.push_back(result);
		// identification author
		who = status.MPI_SOURCE;		
		fprintf(stdout, "Received a response from worker %d\n", who);
		// send new index
		MPI_Send(&i, 1, MPI_INT, who, 1, MPI_COMM_WORLD);
		// update varialbes
		i++;
		count--;
	}
	int missing_response = total_segments - result_array.size();
	
	int end_flag = -1;
	for (i = 0; i < missing_response; i++) {
		double * result = new double[PARAMS+1];
		MPI_Recv(result, PARAMS+1, MPI_DOUBLE, MPI_ANY_SOURCE, 2, 
			MPI_COMM_WORLD, &status);
		result_array.push_back(result);
		who = status.MPI_SOURCE;		
		fprintf(stdout, "Received a response from worker %d\n", who);
	}  

	// send end flag to all workers
	for (i=0; i < workers-1; i++) {
		MPI_Send(&end_flag, 1, MPI_INT, i+1, 1, MPI_COMM_WORLD);
	} 

	// insert results values to DB
	save_result_db(aDatabase, result_array);
	
	// print a basic info about calculation
	show_statistics(result_array);
}


/*
The worker counting a set of params for requested segment. Receiving an index to array.

parameters: 
int aId_node - the id process
*/
void hard_worker(int aId_node){

	MPI_Status status;
	int index_to_array_segment = 0;

	// until receiving the right index (-1 is flag to end)
	while(index_to_array_segment >= 0) {   

		// hey Worker, here is segment for you, start calculation bitch...
		MPI_Recv(&index_to_array_segment, 1, MPI_INT, ROOT_PROCESS, 1, MPI_COMM_WORLD, &status); 

		if (index_to_array_segment != -1) {
			// calculation the best metric (include parameters) for requested segment
			double * result_for_segment = calculation_process(index_to_array_segment);
			// send a result to farmer
			MPI_Send(result_for_segment, PARAMS+1, MPI_DOUBLE, ROOT_PROCESS, 2, MPI_COMM_WORLD); 
		} 
	}

}
