#ifndef Calculation_h
#define Calculation_h

#include "Utils.h"

#include <float.h>
#include <math.h>
#include <algorithm>
#include "Lib/alglib/interpolation.h"
#include <tbb\tbb.h>

/* The time of counting glocose */
extern std::vector<double> *intersticial_time;
/* The value in glocose */
extern std::vector<double> *intersticial;
/* The time of counting blood */
extern std::vector<double> *blood_time;
/* The value in blood */
extern std::vector<double> *blood;
/* The array for save each segment id */
extern int * segmentid;
/* Count of segments */
extern int total_segments;

/* The variables for setting calculation */
extern int iterations;
extern int min_set_of_params;

/* The variables for algorithm */
extern double precision;
extern double A;
extern double B;
extern double G;
extern double H;

/* function for calculation */
void calculation_process(sqlite3 *aDatabase);
alglib::spline1dinterpolant* spline_interpolation(int aSegment);
double count_metrics(alglib::spline1dinterpolant *aInterpolant, double *aSet_of_params, int aCurr_segment);
std::vector<double *> sort_params_by_metric(std::vector<double *> aSet_of_params);
double * check_border_parameters(double aNew_params[]);
void show_statistics(std::vector<double *> aResults);
void clean_up(sqlite3 *aDatabase);
double * generate_parameters();

/* function for working with database */
bool open_database(sqlite3 **aDatabase, char *aDatabaseName);
void save_result_db(sqlite3 *aDatabase, std::vector<double *> aResults);
void load_data_from_db(sqlite3 *aDatabase);
static int callback_total_seq(void *data, int argc, char **argv, char **azColName);
static int callback_read_intersticial(void *data, int argc, char **argv, char **azColName);
static int callback_read_blood(void *data, int argc, char **argv, char **azColName);

/* Loading configuration for application */
void load_config(std::string aName);
void load_bounds(std::string aName);

#endif